import os
import matplotlib.pyplot as plt
import matplotlib.image as mpimg

from tkinter import *
from tkinter import filedialog
from tkinter import messagebox
from PyPDF2 import PdfFileMerger

from datetime import date, datetime
from shutil import copyfile

import toolsphotoalbum as tl

   
# Function to open a file in the system
def open_dir(tit):
   pathdir = filedialog.askdirectory(title=tit)
   return(pathdir)
  
cDirt = "" 
npages = 0
nfotos = 0  
nlayout = 0

today = date.today()
actual = datetime.now()

dia = str(today.day)
mes = str(today.month)
ano = str(today.year)
data = ('-'.join([dia,mes,ano]))

hora = str(actual.hour)+'h'
minuto = str(actual.minute)+'m' 
segundo = str(actual.second)+'s'  
hora = (''.join([hora,minuto,segundo]))


while True:
    
    val1 = messagebox.askyesno("", "Clique SIM para fazer busca das fotos ou NÃO para sair!")
        
    if (val1 == True):
       tit = "Selecione o diretorio das fotos!!:"
       cDirt = open_dir(tit)
       matpath = os.listdir(cDirt)
       val2 = messagebox.askyesno("", "Clique SIM para escolher onde GRAVAR album ou NÃO para sair!")
       if (val2 == True):
          tit = "Selecione o diretorio de Gravação!!:"
          cGrava = open_dir(tit)
       else:
          print("Você escolheu SAIR !")
          print("Encerrando ...!!!")
          exit(0)
    else:
       print("Você escolheu SAIR !")
       print("Encerrando ...!!!")
       exit(0)
    
    npages  = tl.number_of_pages()
    nfotos  = tl.photos_per_page()
    
    if ( (npages == 0) | (nfotos == 0) ):
        break
    

    nlayout = tl.number_of_layout(nfotos)

    cont_page = 1
    inifoto = 0
    fimfoto = 0
    cp = 0
    
    if (nfotos*npages > len(matpath)):
        print("Numero de fotos insuficiente !!!!\n")
        print(''.join(["Voce possui ",str(nfotos)," fotos !!!!\n"]))
        continue
     
      
    cp = len(matpath) - nfotos * npages
    fimfoto = int( (len(matpath)-cp)/npages - 1)
    
    while (cont_page <= npages):
    
        try:
            titulo = ''.join(["Pag.",str(cont_page),"_",data," ",hora,"_.pdf"])
            if ( os.path.exists(''.join([cGrava,"/", titulo]))):
                  os.remove((''.join([cGrava,"/", titulo])))
         
            print(''.join([cGrava,"/", titulo]))
            nl = nlayout["linhas"]
            nc = nlayout["colunas"]
                      
            if (nl > len(matpath)):
              nl <- len(matpath)

            
            print("Aguarde gerando pagina do album ...!")
            lista_de_fotos = tuple(range(inifoto,fimfoto+1))   
            
            fig = plt.figure(cont_page)        
            for iplot in tuple(range(1,nfotos+1)):
              fig.add_subplot(nl,nc,iplot)
              plt.tick_params(axis='x', which='both', bottom=False, 
                top=False, labelbottom=False) 
              plt.tick_params(axis='y', which='both', right=False, 
                left=False, labelleft=False)
              
              print(matpath[lista_de_fotos[iplot-1]])
              file_to_read = (''.join([cDirt,"/",matpath[lista_de_fotos[iplot-1]]]))
              print(file_to_read)
              img = mpimg.imread(file_to_read)
              plt.imshow(img)
              
              wdir = os.getcwd()
              os.chdir(cGrava)
              fig.savefig((''.join(["Pag.",str(cont_page),"_",data," ",hora,"_.pdf"])))
              os.chdir(wdir)
              
                
              
                            
        except ValueError:
              print("Rotina retornou um ERRO!!!")
              print("Encerrando ...!!!")
              break
        
        finally:     
              pass
                           
               
        cont_page += 1
        inifoto +=  nfotos
        fimfoto +=  nfotos
    
    wdir = os.getcwd()
    os.chdir(cGrava)
    matpdf = os.listdir(cGrava)    
    output = ''.join(["Album de fotografias_",data," ",hora,"_.pdf"])
    
    merger = PdfFileMerger()
    for isave in matpdf:
        with open(isave, 'rb') as f: 
            merger.append(f)  
            
    with open(output, 'wb') as f: 
        merger.write(f)    
         
    merger.close()
    
    for cont_page in tuple(range(1,npages+1)):
        if ( os.path.exists(''.join([cGrava,"/","Pag.",str(cont_page),"_",data," ",hora,"_.pdf"]))):
                      os.remove(''.join([cGrava,"/","Pag.",str(cont_page),"_",data," ",hora,"_.pdf"]))
                  
    break

